function [NewAttachM, Newspringlen] = Attach_Heads(Mpos, Apos, delta, AttachM, springlen, N, M)
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

n = size(Mpos, 1);
f = size(Apos, 1);

NewAttachM = AttachM;
Newspringlen = springlen;

Pattach = 1 - (.5)^(1/N); %probability of attaching in time dt
Pdettach = 1 - (.5)^(1/M); %probability of detaching in time dt


%Finding which fibers overlap with the myosin node
Mmatrix = ones(f, 1) * Mpos';
AmatrixPlus = Apos(:, 1) * ones(1, n); %polarized end
AmatrixMinus = Apos(:, 2) * ones(1, n); %unpolarized end

InteractionM = (Mmatrix > AmatrixMinus).*(Mmatrix < (AmatrixPlus - delta)); %Which myosin molecules interact with which Actin fibers

Check_M = ((sum(InteractionM, 1) > 0)' * ones(1, 2)) .* (AttachM == 0); 

[Unattached_Head_M1, Unattached_Head_M2] = find(Check_M == 1); %those heads that are notattached and could potentially attach

for i = 1:length(Unattached_Head_M1),
    Temp = InteractionM(:, Unattached_Head_M1(i)).*(rand(f, 1) < Pattach); %Attach all the connections with probability Pattach
    Select = find(Temp == 1);
    if isempty(Select) == 0,
        Index_Select = randperm(length(Select));
        NewAttachM(Unattached_Head_M1(i), Unattached_Head_M2(i)) = Select(Index_Select(1));
        Newspringlen(Unattached_Head_M1(i), Unattached_Head_M2(i)) = delta;
    end
end

NewAttachM = NewAttachM .* (rand(n, 2) > Pdettach); %Dettach them with a probability of Dettach
Newspringlen = Newspringlen .* (NewAttachM > 0);

end

