function [NewAttachM, Newspringlen] = Attach_Heads_rate(Mpos, Apos, delta, AttachM, springlen, Toff, Tonmax, Tonmin, dt)
%ATTACH_HEADS_RATE attaches kon = K_on*dt heads and detaches the heads
%depending on the strain dependant rate of K_off
%   In a time dt, we expect K_on*dt particles to connect, and K_off(x)*dt
%   particles to dissconects

n = size(Mpos, 1);
f = size(Apos, 1);

NewAttachM = AttachM;
Newspringlen = springlen;

%Pattach = kon/n; %probability of attaching in time dt
%  Pdettach = K_off(; %probability of detaching in time dt
Pattach = 1 - exp(-dt/Toff);

%Finding which fibers overlap with the myosin node
Mmatrix = ones(f, 1) * Mpos';
AmatrixPlus = Apos(:, 1) * ones(1, n); %polarized end
AmatrixMinus = Apos(:, 2) * ones(1, n); %unpolarized end
InteractionM = (Mmatrix > AmatrixMinus).*(Mmatrix < (AmatrixPlus - delta)); %Which myosin molecules interact with which Actin fibers
Check_M = ((sum(InteractionM, 1) > 0)' * ones(1, 2)) .* (AttachM == 0); %same size as AttachM but now 1 if could potentially attach and 0 if already attached


%Note: This is only for 1 fiber
Temp = sum(sum(Check_M));
K = rand(Temp, 1);
NewAttachM(Check_M == 1) = (K < Pattach);
Newspringlen(Check_M == 1) = delta*(K < Pattach);







%Those heads that could potentially attach
%[Unattached_Head_M1, Unattached_Head_M2] = find(Check_M == 1); %those heads that are not attached and could potentially attach
%tic,
%Attach the Heads
%for i = 1:length(Unattached_Head_M1),
%    Temp = InteractionM(:, Unattached_Head_M1(i)).*(rand(f, 1) < Pattach); %Attach all the connections with probability Pattach
 %   Select = find(Temp == 1);
  %  if isempty(Select) == 0,
   %     Index_Select = randperm(length(Select));
    %    NewAttachM(Unattached_Head_M1(i), Unattached_Head_M2(i)) = Select(Index_Select(1));
     %   Newspringlen(Unattached_Head_M1(i), Unattached_Head_M2(i)) = delta;
    %end
%end
%disp('The Evil For Loop')
%toc

%Detach the heads
    Rate = K_off(springlen, delta/100, 1/Tonmax, 1/Tonmin);
    Pdettach = 1 - exp(-Rate*dt);
    NewAttachM = NewAttachM .* (rand(n, 2) > Pdettach); %Dettach them with a probability of Dettach
    Newspringlen = Newspringlen .* (NewAttachM > 0);

end

