#include "math.h"
#include "mex.h"
#include "stdlib.h"
/*
 * timestwo.c - example found in API guide
 *
 * Computational function that takes a scalar and doubles it.
 *
 * This is a MEX-file for MATLAB.
 * Copyright 1984-2007 The MathWorks, Inc.
 */
 
/* $Revision: 1.8.6.3 $ */

    
      
void Attach_test(double *Mpos, double *Apos, double *AttachM, double *delta,
        double *Toff, double *dt, double *BindingD, double *StrikeD,
        double *NewAttachM, double *NewSpringlen, mwSize nM)
{
    mwSize i;
    double x, Patt, Pdatt, rate, tempone, temptwo;
    double Kon;
   
    Kon = 1/ *(Toff);
    
    
    for (i=0; i<nM; i++){
        
        x = *(Mpos+i) - *(Apos+1);
   
        if ( (fmod(x, *(BindingD)) < *(StrikeD) && (x > 0)){
            
            Patt = (1 - exp(-*(dt) * *(Kon)))*100000;
            temptwo = rand() % 100000;
            if (temptwo < Patt){
                *(NewAttachM+i) = 1;
                *(NewSpringlen+i) = *(delta);}
            else{
                *(NewAttachM+i) = 0;
                *(NewSpringlen+i) = 0;}
        }
    
    
    }
}
    

    
    
    
    
    
    for (i=0; i<nM; i++){
        if (*(AttachM+i) > 0){
            /* If head is attached then dettach it based on the strain rate*/
            x = *(Springlen+i);
            rate = Kmin +  (Kmax - Kmin)/(1 + exp(100*x/ *(delta)));
            Pdatt = (1 - exp(-rate* *(dt))) * 100000;
            tempone = rand() % 100000;
     
            if (tempone < Pdatt){
                *(NewAttachM+i) = 0;
                *(NewSpringlen+i) = 0;}
            else{
                *(NewAttachM+i) = 1;
                *(NewSpringlen+i) = *(Springlen+i);}
                
            
        }
        else {
            
            Patt = (1 - exp(-*(dt)/ *(Toff)))*100000;
            temptwo = rand() % 100000;
            if (temptwo < Patt){
                *(NewAttachM+i) = 1;
                *(NewSpringlen+i) = *(delta);}
            else{
                *(NewAttachM+i) = 0;
                *(NewSpringlen+i) = 0;}
        }
        
        if (*(AttachM+nM+i) > 0){
            x = *(Springlen+nM+i);
            /*K_off(x, delta, Tonmax, Tonmin, rate);*/
            rate = Kmin +  (Kmax - Kmin)/(1 + exp(100*x/ *(delta)));
            Pdatt = (1 - exp(-rate* *(dt))) * 100000;
            tempone = rand() % 100000;
     
            if (tempone < Pdatt){
                *(NewAttachM+nM+i) = 0;
                *(NewSpringlen+nM+i) = 0;}
            else{
                *(NewAttachM+nM+i) = 1;
                *(NewSpringlen+nM+i) = *(Springlen+nM+i);}
                
        }
        else {
            
            Patt = (1 - exp(-*(dt)/ *(Toff)))*100000;
            temptwo = rand() % 100000;
            if (temptwo < Patt){
                *(NewAttachM+nM+i) = 1;
                *(NewSpringlen+nM+i) = *(delta);}
            else{
                *(NewAttachM+nM+i) = 0;
                *(NewSpringlen+nM+i) = 0;}
        }
    }
            
            
}

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[]){
  double *Mpos, *Apos, *AttachM, *delta, *Toff, *dt, *BindingD, *StrikeD, *NewAttachM, *NewSpringlen;
  mwSize nM;
  
  /*M is rows N is columns*/
   nM = mxGetM(prhs[0]);
 
  Mpos = mxGetPr(prhs[0]);
  Apos = mxGetPr(prhs[1]);
  AttachM = mxGetPr(prhs[2]);
  delta = mxGetPr(prhs[3]);
  Toff = mxGetPr(prhs[4]);
  dt = mxGetPr(prhs[5]);
  BindingD = mxGetPr(prhs[6]);
  StrikeD = mxGetPr(prhs[7]);
  
   
  plhs[0] = mxCreateDoubleMatrix(nM, 2, mxREAL);
  plhs[1] = mxCreateDoubleMatrix(nM, 2, mxREAL);
  NewAttachM = mxGetPr(plhs[0]);
  NewSpringlen = mxGetPr(plhs[1]);
  
  /* Call the timestwo subroutine. */
 
  Attach_test(Mpos, Apos, AttachM, delta, Toff, dt, BindingD, StrikeD, NewAttachM, NewSpringlen, nM);
  return;
}
