function Display_Molecular(Mpos, Apos, Mlen, springlen, delta, AttachM)
%DISPLAY_ALL Display All of the constituents and connections
%Myosin is green with two heads

hold off;

n = size(Mpos, 1);
f = size(Apos, 1);

MposX = Mpos;
HposX = Mpos*ones(1,2) + springlen;
AposX = Apos(:, 1);

MposY = linspace(1, -1, n)';
AposY = (linspace(-5, 5, f) + .1)';

HposY = [(MposY + .2), (MposY - .2)];

HposY(AttachM > 0) = AposY(AttachM(AttachM > 0));

Xpos = [MposX; HposX(:, 1); HposX(:, 2); AposX];
Ypos = [MposY; HposY(:, 1); HposY(:, 2); AposY];

S = [15*ones(n,1); 30*ones(2*n,1); 15*ones(f, 1)]; %size of the points
C = [ones(3*n, 1)*[0, 1, 0];ones(f, 1)*[0,0,1]];

scatter(Xpos, Ypos, S, C, 'filled');

hold all;
%Draw Mysoin
for i = 1:n,
    %Draw Mysoin tail
    plot([MposX(i), MposX(i) - Mlen], [MposY(i), MposY(i)], 'LineWidth', 3, 'Color', [0, 1, 0]);
    %Draw Mysoin heads
    %color_head1 = floor(100*springlen(i, 1)/delta)/100
    color_head1 = 0;
    %color_head2 = floor(100*springlen(i, 2)/delta)/100
    color_head2 = 0;
    plot([MposX(i), HposX(i, 1)], [MposY(i), HposY(i, 1)], 'LineWidth', 3, 'Color', [color_head1, 1 - color_head1, 0]);
    plot([MposX(i), HposX(i, 2)], [MposY(i), HposY(i, 2)], 'LineWidth', 3, 'Color', [color_head2, 1 - color_head2, 0]);
end

%Draw Actin
for i = 1:f,
    plot([AposX(i), Apos(i, 2)], [AposY(i), AposY(i)], 'LineWidth', 1, 'Color', [0, 0, 1]);
end







end

