/* $Revision: 1.8.6.2 $ */
/*=========================================================
 * convec.c
 * example for illustrating how to use pass complex data 
 * from MATLAB to C and back again
 *
 * convolves  two complex input vectors
 *
 * This is a MEX-file for MATLAB.
 * Copyright 1984-2006 The MathWorks, Inc.
 *=======================================================*/
#include "mex.h"

/* computational subroutine */
void Assing_ForceC( double *AttachM, double *Springlen, double *K, mwSize nM,
             double *Mforce, double *Aforce)
{
    mwSize j;
  
   
   for (j=0; j<nM; j++){
       *(Mforce+j) = *(K)* *(Springlen+j) + *(K)* *(Springlen+nM+j);
       
       if ( *(AttachM+j) > 0)
           *(Aforce+j) = *(Aforce+j) - *(K)* *(Springlen+j);
       if ( *(AttachM+nM + j) > 0)
           *(Aforce+j) = *(Aforce+j) - *(K)* *(Springlen+nM+j);
   }

}

/* The gateway routine. */
void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[] )
{
    double  *AttachM, *Springlen, *K, *Mforce, *Aforce;
    mwSize  nM, nA;
    
    /* check for the proper number of arguments */
    if(nrhs != 3)
      mexErrMsgTxt("Three inputs required.");
    if(nlhs > 2)
      mexErrMsgTxt("Too many output arguments.");
    /*Check that both inputs are row vectors*/
     /*M is rows N is columns
  
    /* get the length of each input vector */
    nM = mxGetM(prhs[0]);
    /*nA = mxGetPr(prhs[3]);*/
    nA = 1;
     

    /* get pointers to the real and imaginary parts of the inputs */
    AttachM = mxGetPr(prhs[0]);
    Springlen = mxGetPr(prhs[1]);
    K = mxGetPr(prhs[2]);
    
    
  
    /* create new arrays for the outputs and set the output pointers to them */
    
    plhs[0] = mxCreateDoubleMatrix(nM, 1, mxREAL);
    plhs[1] = mxCreateDoubleMatrix(nA, 1, mxREAL);
    Mforce = mxGetPr(plhs[0]);
    Aforce = mxGetPr(plhs[0]);

    /* call the C subroutine */
    Assing_ForceC(AttachM, Springlen, K, nM, Mforce, Aforce);

    return;
}




