
#include "mex.h"
#include "stdlib.h"
/*
 * timestwo.c - example found in API guide
 *
 * Computational function that takes a scalar and doubles it.
 *
 * This is a MEX-file for MATLAB.
 * Copyright 1984-2007 The MathWorks, Inc.
 */
 
/* $Revision: 1.8.6.3 $ */

void KoffC(double *x, double *kmax, double *kmin, double *delta, double *y)
{
  *(y) = *(kmin) +  ( *(kmax) - *(kmin))/(1 + exp( *(x)/ *(delta)));
}

void mexFunction( int nlhs, mxArray *plhs[],
                  int nrhs, const mxArray *prhs[] )
{
  double *x,*kmax, *kmin, *delta, *y;
  
  /* Create matrix for the return argument. */
  plhs[0] = mxCreateDoubleMatrix(1,1, mxREAL);
  y = mxGetPr(plhs[0]);
  
  /* Assign pointers to each input and output. */
  x = mxGetPr(prhs[0]);
  delta = mxGetPr(prhs[1]);
  kmax = mxGetPr(prhs[2]);
  kmin = mxGetPr(prhs[3]);
  
  y = mxGetPr(plhs[0]);
  
  /* Call the timestwo subroutine. */
  KoffC(x, kmax, kmin, delta, y);
  return;
}
