#include <iostream>
#include <fstream>
using namespace std;
//#define ELMAT(mm,i,j,rows,cols) (mm[i*cols+j])
//#define ELMTYPE double
#include <math.h>

#include "auxlrs.h"
//#include "four1.h"
//#include "realft.h"

#include "a_par.h"
#include "b_par.h"


void union_init(int *a, size_t n)
{
	for (int i=0; i < n; ++i)
		a[i] = -1;
}

int union_root(int *a, size_t i)
{
	int j = i; 
	while (a[i] != -1) 
		i = a[i]; 
	if (j != i) 
		a[j] = i; 
	return i;
}

bool union_same(int *a, size_t i, size_t j)
{
	return union_root(a,i) == union_root(a,j);
}

// precondition: i and j are not in the same set
void union_join(int *a, size_t i, size_t j)
{
	a[union_root(a,j)] = i;
}



int main()
{
	//====================================================================================================================
	//


	
	double P_C_array[A_sets];
	

	
	const int Bdny_C = C_set_size;
	
	
	int NumActin = A_sets*A_set_size; // Number of filaments
	int NumCross = C_sets*C_set_size+Bdny_C; // Number of Cross Links
		
	
	//====================================================================================================================
	
	//====================================================================================================================

	
	long * idum = new long; // dummy long for random number generation
	(*idum) = 100;
	
	int t=0, i=0, j=0, k=0, m=0;
	
	
	int Bound_id[NumCross]; // if >0, then Bound_id[NumMyosin] actin is attached to Myosin
	int Cross_id[NumCross]; // same as Bound_id
	
	
	int Clus_hist[NumActin];
	
	//--------------------------------------------------------------------------------------------------------------------
	// For Cluster Formation
	
	int ClusCount = 0; // the count of the cluster. Cluscount/2 is the number of crosslinkers
	int LabelC[2*NumCross];
	int LabelR[2*NumCross];
	int LabelF[NumActin];
	int Labels[2*NumCross];
	int Labels_mid[2*NumCross];
	int Clus_size[2*NumCross];
	
	int Largest_Clus[10];
	
	
	
	
	
	//int test = 0;

	//double force_test = 0.0;
	//--------------------------------------------------------------------------------------------------------------------
	
	//create the file for output
	
	ofstream* file = new ofstream("cross_out.m");
	
	(*file)<<"A_num = "<<NumActin<<";"<<endl;
	(*file)<<"C_num = "<<NumCross<<";"<<endl;
	
	(*file)<<"Time = [];"<<endl;
	(*file)<<"P_conn = [];"<<endl;
	(*file)<<"Clus_num = [];"<<endl;
	(*file)<<"Largest_clus = [];"<<endl;
	

	file->close();
	delete file;
	
	//====================================================================================================================

	// Assing the position to the crosslinkers
	for (i=0; i<NumCross; i++) {

		Bound_id[i] = -1;
		Cross_id[i] = -1;
	}
	
	for (i=0; i<NumActin; i++) {
		Clus_hist[i] = 0;
	}
	
	
	
	
	
	//====================================================================================================================
	
	//====================================================================================================================
	//====================================================================================================================
	
	//cout << "Destruction Probability = " << NumFilaments*nu_d*dt<<endl;
	
	// time loop
	for(t=0; t< 2*2001 ;t++)
	{
	
		
		cout<<"Iteration # "<<t<<endl;
		
		
		
		
		
		//----------------------------------------------------------------------------------------------------------------
		// Check Interactions, bind/unbind Crosslinkers
		int tmp=0;
		for (k=0; k<C_sets; k++) {
			
		
			
			for (j=k*C_set_size; j<((k+1)*C_set_size); j++) // Attach the crosslinkers to the actin
			{
				tmp = int(ran2(idum)*2*A_set_size) + k*A_set_size;
				Bound_id[j] = tmp;
			
				while (1) {
					tmp = int(ran2(idum)*2*A_set_size) + k*A_set_size;
		
					if (Bound_id[j] != tmp) {
						Cross_id[j] = tmp;

						break;
					}
				}
			}
		}
		
		for (k=(NumCross - Bdny_C/2); k<NumCross; k++) {
			
			tmp = int(ran2(idum)*A_set_size);
			Bound_id[k] = tmp;
			
			while (1) {
				tmp = int(ran2(idum)*A_set_size);
				
				if (Bound_id[k] != tmp) {
					Cross_id[k] = tmp;
					
					break;
				}
			}
		}
		
		for (k=(NumCross - Bdny_C); k<NumCross - Bdny_C/2; k++) {
			
			tmp = int(ran2(idum)*A_set_size) + (A_sets- 1)*A_set_size;
			Bound_id[k] = tmp;
			
			while (1) {
				tmp = int(ran2(idum)*A_set_size) + (A_sets- 1)*A_set_size;
				
				if (Bound_id[k] != tmp) {
					Cross_id[k] = tmp;
					
					break;
				}
			}
		}
		
		
		
	/*		
		cout << "Bound_id = [" << endl;
		for (k=0; k<C_sets; k++) {
			for (j=k*C_set_size; j<((k+1)*C_set_size); j++) // Attach the crosslinkers to the actin
			{
				cout << Bound_id[j] << "  ";
			}
			cout << endl;
		}
		cout << "]" << endl; 
		
		cout << "Cross_id = [" << endl;
		for (k=0; k<C_sets; k++) {
			for (j=k*C_set_size; j<((k+1)*C_set_size); j++) // Attach the crosslinkers to the actin
			{
				cout << Cross_id[j] << "  ";
			}
			cout << endl;
		}
		cout << "]" << endl; 
			*/
			
		//----------------------------------------------------------------------------------------------------------------
		//Calculate force, Build Cluster, Move the constituents
		
		for (k=0; k<NumActin; k++){ // initialize the force, drag to 0
			LabelF[j] = -1;
		}
		
		for (k=0; k<A_sets; k++) {
			P_C_array[k] = 0;
		}
		
		
		// Build Clusters. Figure out which filaments are connected (directly or indirectly) to other filament
		
		for (j=0; j<(2*NumCross); j++){ // Initialize all labels to -1
			LabelC[j] = -1;
			LabelR[j] = -1;
			Labels[j] = -1;
			Labels_mid[j] = -1;
			Clus_size[j] = -1;
		}

		ClusCount = 0; // The size of the  of the clusters
		
		// Go through all the Crosslinkers and get their indecies
		for (j=0; j<NumCross; j++) { // Build the Labels
				LabelC[ClusCount] = ClusCount; // Label of the Crosslinkers
				LabelC[ClusCount+1] = ClusCount; 
				LabelR[ClusCount] = Bound_id[j]; // Label of the actin
				LabelR[ClusCount+1] = Cross_id[j];
				ClusCount += 2; // Count by 2 because each crosslinker has 2 attached heads

		}
		
	
		// Calculate 
		
		int *a = new int[NumActin];
		union_init(a,NumActin);
		for (int i=0; i < ClusCount; i+=2)
			if (!union_same(a,LabelR[i],LabelR[i+1]))
				union_join(a,LabelR[i],LabelR[i+1]);
		for (int i=0; i < NumActin; ++i)
			LabelF[i] = union_root(a,i);
		delete [] a;
		
	

		// Go through all the myosin and calculate the force
		
		
		
		
		// Count the clusters
		tmp = 0;
		int check = 0;
		int incr = 0;
		//int countc = 0;
		for (j=0; j<NumActin; j++) {
			tmp = LabelF[j]; // pick a label
			
			check = 0;
			for (k=0; k<incr; k++) {
				if (Labels[k] == tmp) // if label is in the sorted set
					check = 1; // then dont put it in the set
			}
			
			if (check == 0){ // otherwise put it in the set
				Labels[incr] = tmp;
				incr++;
			}
			
		} 
		
		
		for (j=0; j<incr; j++) {
			
			check = 0;
			for (k=0; k<NumActin; k++) {
				if (LabelF[k] == Labels[j]) {
					check++;
				}
			}
			//cout << check;
			Clus_hist[check-1]++;
			
		}
		
		int check_mid = 0;
		int incr_mid = 0;
		for (k=center*A_set_size; k<(center+1)*A_set_size; k++) {
			tmp = LabelF[k];
			
			check_mid = 0;
			for (j=0; j<incr_mid; j++) {
				if (Labels_mid[j] == tmp) {
					check_mid = 1;
				}
			}
			
			if (check_mid == 0) {
				Labels_mid[incr_mid] = tmp;
				incr_mid++;
			}
			
		}
		
		
		for (j=0; j<incr_mid; j++) {
			check_mid = 0;
			for (k=0; k<NumActin; k++) {
				if (LabelF[k] == Labels_mid[j]) {
					check_mid++;
				}
			}
			Clus_size[j] = check_mid;
		}
		
		
		
		for (k=0; k<10; k++){
			Largest_Clus[k] = 0;
		}
		
		for (j=0; j<incr_mid; j++) {
			tmp = Clus_size[j];
			if (tmp > Largest_Clus[0]) {
				Largest_Clus[0] = tmp;
			}
		}
		
		for (k=1; k<10; k++){	
			for (j=0; j<incr_mid; j++) {
				tmp = Clus_size[j];
				if (tmp > Largest_Clus[k] && tmp < Largest_Clus[k-1]) {
					Largest_Clus[k] = tmp;
				}
			}
		
		}
		
		
		/*
		cout << "incr_mid = " << incr_mid << endl;
		
		cout << "Clus size = [";
		for (k=0; k<incr_mid; k++) {
			cout << Clus_size[k] << "  ";
		}
		cout << "]" << endl;
		
		cout << "Largest Clus = [";
		for (k=0; k<10; k++) {
			cout << Largest_Clus[k] << "  ";
		}
		cout << "]" << endl; */
		
		
		
		// Fraction of elements in set m that are connected to an element in set m_0=20
		int count_con;
		for (m=0; m<A_sets; m++) {
	
			count_con = 0;
			for (j=m*A_set_size; j<(m+1)*A_set_size; j++) {
				for (k=center*A_set_size; k<(center+1)*A_set_size; k++) {
					if (LabelF[j] == LabelF[k] && j != k) {
						count_con++;
						break;
					}
				}
			}
			
			P_C_array[m] = double(count_con)/A_set_size;
		}
	
		/*
		cout << "LabelF = " << endl;
		
		for (m=0; m<A_sets; m++){
			for (k=m*A_set_size; k<(m+1)*A_set_size; k++) {
				cout << LabelF[k] << " ";
			}
			cout << endl;
		}
		
		cout << "P_C_array = ";
		for (m=0; m<A_sets; m++) {
			cout << P_C_array[m] << " ";
		}
		cout << endl << endl;
		 */
		
		
		//cout << "Average Connection of actins = " << Avg_con << "  Number of clusters = " << incr << endl;

	

		// Record the data

			ofstream myfile;
			myfile.open("cross_out.m", ios::app);

			myfile<<"Time=[Time; "<<t<<" ];"<<endl;
			myfile<<"P_conn=[ P_conn;[";
			for (m=0; m<A_sets; m++) 
			{
				myfile<<P_C_array[m] << " ";
			}
			myfile<<"]];"<<endl;
		
		
			myfile<<"Clus_num=[ Clus_num;" << incr << "];"<<endl;
		
			myfile<<"Largest_clus=[Largest_clus;[";
			for (m=0; m<10; m++) 
			{
				myfile<<Largest_Clus[m] << " ";
			}
			myfile<<"]];"<<endl;
			
			myfile.close();
		
		
	}
	
	ofstream myfile;
	myfile.open("cross_out.m", ios::app);
	
	myfile<<"Clus_hist = [";
	
	for (k=0; k<NumActin; k++) {
		myfile << Clus_hist[k] << "  ";
	}
	myfile<<"];"<<endl;
	
	
	myfile.close();
	
	
	return 0;
}
