#include <iostream>
#include <fstream>
using namespace std;
//#define ELMAT(mm,i,j,rows,cols) (mm[i*cols+j])
//#define ELMTYPE double
#include <math.h>

#include "auxlrs.h"
#include "four1.h"
#include "realft.h"




void union_init(int *a, size_t n)
{
	for (int i=0; i < n; ++i)
		a[i] = -1;
}

int union_root(int *a, size_t i)
{
	int j = i; 
	while (a[i] != -1) 
		i = a[i]; 
	if (j != i) 
		a[j] = i; 
	return i;
}

bool union_same(int *a, size_t i, size_t j)
{
	return union_root(a,i) == union_root(a,j);
}

// precondition: i and j are not in the same set
void union_join(int *a, size_t i, size_t j)
{
	a[union_root(a,j)] = i;
}



int main()
{
	//====================================================================================================================
	//
	
	int NumActin = 1000; // Number of filaments
	int NumCross = 300; // Number of Cross Links
	
	
	//====================================================================================================================
	
	//====================================================================================================================
	
	
	long * idum = new long; // dummy long for random number generation
	(*idum) = 100;
	
	int t=0, i=0, j=0, k=0;
	
	
	int Bound_id[NumCross]; // if >0, then Bound_id[NumMyosin] actin is attached to Myosin
	int Cross_id[NumCross]; // same as Bound_id
	
	
	int Clus_hist[NumActin];
	
	//--------------------------------------------------------------------------------------------------------------------
	// For Cluster Formation
	
	int ClusCount = 0; // the count of the cluster. Cluscount/2 is the number of crosslinkers
	int LabelC[2*NumCross];
	int LabelR[2*NumCross];
	int LabelF[NumActin];
	int Labels[2*NumCross];
	
	
	
	
	//int test = 0;
	
	//double force_test = 0.0;
	//--------------------------------------------------------------------------------------------------------------------
	
	//create the file for output
	
	ofstream* file = new ofstream("cross_out.m");
	
	(*file)<<"A_num = "<<NumActin<<endl;
	(*file)<<"C_num = "<<NumCross<<endl;
	
	(*file)<<"P_conn = [];"<<endl;
	(*file)<<"Clus_num = [];"<<endl;
	
	file->close();
	delete file;
	
	//====================================================================================================================
	
	// Assing the position to the crosslinkers
	for (i=0; i<NumCross; i++) {
		
		Bound_id[i] = -1;
		Cross_id[i] = -1;
	}
	
	for (i=0; i<NumActin; i++) {
		Clus_hist[i] = 0;
	}
	
	
	
	
	//====================================================================================================================
	
	//====================================================================================================================
	//====================================================================================================================
	
	//cout << "Destruction Probability = " << NumFilaments*nu_d*dt<<endl;
	
	// time loop
	for(t=0; t< 2001 ;t++)
	{
		
		
		cout<<"Iteration # "<<t<<endl;
		
		//----------------------------------------------------------------------------------------------------------------
		// Check Interactions, bind/unbind Crosslinkers
		
		int tmp=0;
		for (j=0; j<NumCross; j++) // Attach the crosslinkers to the actin
		{
			tmp = int(ran2(idum)*NumActin);
			Bound_id[j] = tmp;
			
			while (1) {
				tmp = int(ran2(idum)*NumActin);
				
				if (Bound_id[j] != tmp) {
					Cross_id[j] = tmp;
					break;
				}
				
			}
			
		}
		
		
		
		
		//----------------------------------------------------------------------------------------------------------------
		//Calculate force, Build Cluster, Move the constituents
		
		for (k=0; k<NumActin; k++){ // initialize the force, drag to 0
			LabelF[j] = -1;
		}
		
		
		// Build Clusters. Figure out which filaments are connected (directly or indirectly) to other filament
		
		for (j=0; j<(2*NumCross); j++){ // Initialize all labels to -1
			LabelC[j] = -1;
			LabelR[j] = -1;
			Labels[j] = -1;
		}
		
		ClusCount = 0; // The size of the  of the clusters
		
		// Go through all the Crosslinkers and get their indecies
		for (j=0; j<NumCross; j++) { // Build the Labels
			LabelC[ClusCount] = ClusCount; // Label of the Crosslinkers
			LabelC[ClusCount+1] = ClusCount; 
			LabelR[ClusCount] = Bound_id[j]; // Label of the actin
			LabelR[ClusCount+1] = Cross_id[j];
			ClusCount += 2; // Count by 2 because each crosslinker has 2 attached heads
			
		}
		
		
		// Calculate 
		
		int *a = new int[NumActin];
		union_init(a,NumActin);
		for (int i=0; i < ClusCount; i+=2)
			if (!union_same(a,LabelR[i],LabelR[i+1]))
				union_join(a,LabelR[i],LabelR[i+1]);
		for (int i=0; i < NumActin; ++i)
			LabelF[i] = union_root(a,i);
		delete [] a;
		
		
		
		// Go through all the myosin and calculate the force
		
		
		
		
		// Count the clusters
		tmp = 0;
		int check = 0;
		int incr = 0;
		//int countc = 0;
		for (j=0; j<NumActin; j++) {
			tmp = LabelF[j]; // pick a label
			
			check = 0;
			for (k=0; k<incr; k++) {
				if (Labels[k] == tmp) // if label is in the sorted set
					check = 1; // then dont put it in the set
			}
			
			if (check == 0){ // otherwise put it in the set
				Labels[incr] = tmp;
				incr++;
			}
			
		} 
		
		
		for (j=0; j<incr; j++) {
			
			check = 0;
			for (k=0; k<NumActin; k++) {
				if (LabelF[k] == Labels[j]) {
					check++;
				}
			}
			//cout << check;
			Clus_hist[check-1]++;
			
		}
		
		
		int count_con;
		double Avg_con = 0;
		for (k=0; k<NumActin; k++){ 
			
			count_con = 0; 
			for (j=0; j<NumActin; j++) {
				if (LabelF[k] == LabelF[j] && k != j) {
					count_con++;
				}
			}
			
			Avg_con += double(count_con)/NumActin;
			
		}
		
		Avg_con = Avg_con/NumActin;
		
		//cout << "Average Connection of actins = " << Avg_con << "  Number of clusters = " << incr << endl;
		
		
		
		// Record the data
		
		ofstream myfile;
		myfile.open("cross_out.m", ios::app);
		
		myfile<<"Time=[ "<<t<<" ];"<<endl;
		myfile<<"P_conn=[ P_conn;" << Avg_con << "];"<<endl;
		myfile<<"Clus_num=[ Clus_num;" << incr << "];"<<endl;
		
		myfile.close();
		
		
	}
	
	ofstream myfile;
	myfile.open("cross_out.m", ios::app);
	
	myfile<<"Clus_hist = [";
	
	for (k=0; k<NumActin; k++) {
		myfile << Clus_hist[k] << "  ";
	}
	myfile<<"];"<<endl;
	
	
	myfile.close();
	
	
	return 0;
}
