#include <math.h>

const double Pi = 3.1415926535897932385;

void realft(double data[], unsigned long n, int isign)
{
	void four1(/*float*/double data[], unsigned long nn, int isign);
	unsigned long i,i1,i2,i3,i4,np3;
	/*float*/ double c1=0.5,c2,h1r,h1i,h2r,h2i;
	double wr,wi,wpr,wpi,wtemp,theta;

	theta=3.141592653589793/(double) (n>>1);
	if (isign == 1) {
		c2 = -0.5;
		four1(data,n>>1,1);
	} else {
		c2=0.5;
		theta = -theta;
	}
	wtemp=sin(0.5*theta);
	wpr = -2.0*wtemp*wtemp;
	wpi=sin(theta);
	wr=1.0+wpr;
	wi=wpi;
	np3=n+3;
	for (i=2;i<=(n>>2);i++) {
		i4=1+(i3=np3-(i2=1+(i1=i+i-1)));
		h1r=c1*(data[i1]+data[i3]);
		h1i=c1*(data[i2]-data[i4]);
		h2r = -c2*(data[i2]+data[i4]);
		h2i=c2*(data[i1]-data[i3]);
		data[i1]=h1r+wr*h2r-wi*h2i;
		data[i2]=h1i+wr*h2i+wi*h2r;
		data[i3]=h1r-wr*h2r+wi*h2i;
		data[i4] = -h1i+wr*h2i+wi*h2r;
		wr=(wtemp=wr)*wpr-wi*wpi+wr;
		wi=wi*wpr+wtemp*wpi+wi;
	}
	if (isign == 1) {
		data[1] = (h1r=data[1])+data[2];
		data[2] = h1r-data[2];
	} else {
		data[1]=c1*((h1r=data[1])+data[2]);
		data[2]=c1*(h1r-data[2]);
		four1(data,n>>1,-1);
	}
}
/* (C) Copr. 1986-92 Numerical Recipes Software v%1jw3#R0(9p+,s021&$. */

void rlft(double data[], unsigned long nn)
{
	int i=0;

	realft(data,nn,1);

	for(i=1; i<=nn; i++)
	{
		data[i] *= 2.0/nn;
	}
}

void invrlft(double data[], unsigned long nn)
{
	int i=0;

	realft(data,nn,-1);

	for(i=1; i<=nn; i++)
	{
		data[i] *= 1;
	}
}

void convft(double f[], double g[], double rslt[], unsigned long nn, double Lx)
{
	int i=0;

	for(i=1; i<=nn-1; i+=2)
	{
		/*float*/ double a1 = f[i];
		/*float*/ double a2 = g[i];

		/*float*/ double b1 = f[i+1];
		/*float*/ double b2 = g[i+1];

		rslt[i] = Lx*(a1*a2-b1*b2)/2;
		rslt[i+1] = Lx*(a1*b2+b1*a2)/2;
	}
}
