function [New_Connections_ends] = Connection_turnover(Actin, Prop)
%CONNECTION_TURNOVER destroys the connection between individual myosin and
%actin with a certain probability
%   For each actin fiber we calculate the its total force as well as how
%   many myosin nodes are located at its polarized end. The probability of the connection turnover is
%   proportional to the quotient of the two quantities.
%   When a connection has underwent turnover it becomes seperated from the
%   asterick and its polarized end moves a distance away from the asterick
%   in the direction opossite to its polarization.

%Note N = Thalflife/dt

New_Connections_ends = Prop.connections_ends;
Th = Actin.t_half/Prop.dt;
Prob = 1 - (.5).^(1./Th); %Probability of detaching each connection in time dt

Conn = find(Prop.connections_ends > 0);

New_Connections_ends(Conn) = (rand(length(Conn), 1) > Prob);



%{


NewFibers = Fibers;
Pol = sign(Fibers(:, 1) - Fibers(:, 2));
NewAttachedEnds = AttachedEnds;

[Fall, Nall] = find(AttachedEnds > 0);

if isempty(Fall) == 0,
    Fall = sort(Fall);
    FiltF = [1; (Fall(2:end) - Fall(1:end-1))];
    Fconn = Fall(FiltF ~= 0);
    
    AttMyosin = sum(abs(Attached(Fconn, :)), 2);
    %ConnMyosin = sum(AttachedEnds(Fconn, :), 2);
    
    %Th = halflife*(ConnMyosin./AttMyosin);
    Th = N*ones(size(AttMyosin));
    Prob = 1 - (.5).^(1./Th);
    
    %Prob = .1;
    
    
    Turnoverbool = (rand(length(Prob), 1) > Prob) ;
    
    NewAttachedEnds(Fconn, :) = (Turnoverbool* ones(1, size(AttachedEnds, 2))) .* AttachedEnds(Fconn, :);
    
    NewFibers(Fconn, 1) = Fibers(Fconn, 1) - 2*R*Pol(Fconn) .* (Turnoverbool == 0);
    NewFibers(Fconn, 2) = Fibers(Fconn, 2) - 2*R*Pol(Fconn) .* (Turnoverbool == 0);
end
  %}  
end