function Display_all(nodes, fibers)
%Display_all plots the actin and the myson
%   Myosin is green, Actin is blue. The blue dot at the end of the actin
%   fiber is the polarization direction of the fiber

hold off;

n = size(nodes, 1);
f = size(fibers, 1);

Xpos = [nodes; fibers(:, 1)];
Ypos = [zeros(n, 1);[(-10+20/f) : 20/f : 10]']+f/2;
S = [50*ones(n,1);15*ones(f,1)]; %size of the points
C = [ones(n, 1)*[0, 1, 0];ones(f, 1)*[0,0,1]];

scatter(Xpos, Ypos, S, C, 'filled');

for i = 1:f
    hold all;
    plot([fibers(i, 1), fibers(i, 2)], [Ypos(n+i), Ypos(n+i)], 'b-');
end


end

