function [Connections_Ends] = Identify_connections_ends(New_Myosin, Myosin, Actin, New_Actin, Props)
%IDENTIFY_CONNECTIONS_ENDS We check if the myosin has moved to the ends

n = Myosin.num;
f = Actin.num;

Nmatrix_before = ones(f, 1) * Myosin.pos';
Nmatrix_after = ones(f, 1) * New_Myosin.pos';

Fmatrix_before = Actin.pos(:, 1) * ones(1, n);
Fmatrix_after = New_Actin.pos(:, 1) * ones(1, n);
PolMatrix = Actin.polarization * ones(1, n);


Con1 = (PolMatrix > 0).*(Nmatrix_before < Fmatrix_before).*(Nmatrix_after > Fmatrix_after);

Con2 = (PolMatrix < 0).*(Nmatrix_before > Fmatrix_before).*(Nmatrix_after < Fmatrix_after);

Connections_Ends = (Con1 + Con2 + Props.connections_ends) > 0;



end

