function [Att] = Indentify_connections(Myosin, Actin)
%IDENTIFY_CONNECTIONS find the Matrix Attached and AttachedEnds

%Dimensions
n = Myosin.num;
f = Actin.num;

%R = Myosin.capture_radius;

Nmatrix = ones(f, 1) * Myosin.pos';
FmatrixPlus = Actin.pos(:, 1) * ones(1, n);%polarized end
FmatrixMinus = Actin.pos(:, 2) * ones(1, n);%unpolarized end
PolMatrix = Actin.polarization * ones(1, n); %polarization

%For -X polarizations
%Con1 is condition for being between the polazired and the unpolarized end
Con1 =  (Nmatrix > FmatrixPlus).*(Nmatrix < FmatrixMinus).*(PolMatrix < 0);
%Conper1 is a condition for being connected with periodic conditions 
%Conper1 = (Nmatrix < (FmatrixPlus - R)).*(Nmatrix < (mod(FmatrixMinus + R, 2*pi*Rring))).*(PolMatrix < 0).*((FmatrixMinus + R) > 2*pi*Rring);

%For +X polarizations
Con2 =  (Nmatrix < FmatrixPlus).*(Nmatrix > FmatrixMinus).*(PolMatrix > 0);
%Conper2 = (Nmatrix > (FmatrixPlus + R)).*(Nmatrix > (mod(FmatrixMinus - R, 2*pi*Rring))).*(PolMatrix > 0).*((FmatrixMinus - R) < 0);

%Att = Con2 + Conper2 - Con1 - Conper1;

Att = Con2 - Con1;
%Attached gives 1 for Attached(i, j) if node j is connected to fiber i and
%fiber i is polarized +X, gives -1 if polarized -X
%Otherwise it gives zero

%{
Attcon1 = (Nmatrix > (FmatrixPlus - R)).*(Nmatrix < (FmatrixPlus + R));
%Attcon2 = (Nmatrix < (FmatrixPlus - R)).*(Nmatrix < mod((FmatrixPlus + R), 2*pi*Rring)).*((FmatrixPlus + R) > 2*pi*Rring);
%Attcon3 = (Nmatrix > mod((FmatrixPlus - R), 2*pi*Rring)).*(Nmatrix > (FmatrixPlus + R)).*((FmatrixPlus - R) < 0);
%AttEnds = Attcon1 + Attcon2 + Attcon3;
AttEnds = Attcon1;

%This gives the nodes that are attached the polarized end of the fiber


Att = Att.*(AttEnds == 0);
%The nodes that are attached to the polarized end are no longer considered
%to be attached because they no longer apply a force
%}
end

