#include <iostream>
#include <fstream>
using namespace std;
//#define ELMAT(mm,i,j,rows,cols) (mm[i*cols+j])
//#define ELMTYPE double
#include <math.h>

#include "auxlrs.h"
#include "four1.h"
#include "realft.h"



int Interact(double Mx, double Ax, double Actin_len, double Sys_Len){
	
	if ((Mx<(Ax + Actin_len/2))&&(Mx>(Ax - Actin_len/2))) {
		return 1;
	}
	else if((Mx<(Ax + Actin_len/2 + Sys_Len))&&(Mx>(Ax - Actin_len/2 + Sys_Len))){
		return 1;
	}
	else if((Mx<(Ax + Actin_len/2 - Sys_Len))&&(Mx>(Ax - Actin_len/2 - Sys_Len))){
		return 1;
	}
	else {
		return 0;
	}
}



int main()
{
	//====================================================================================================================
	//
	const double D = 0.1; // Diffusion constant
	
	/*const*/ double alpha = 1; //strength of the interaction
	
	
	int NumActin = 100; // Number of filaments
	int NumMyosin = 100; // Number of Free Myosin
	
	
	
	const double Lx = 200.0; //The size of the system
	
	//const double nu = 20.0*2 *10;
	//const double nu_d = 0.0; // Destroy rate per second
	//const double nu = nu_d*NumFilaments/Lx; // Destroy rate per second per unit length
	
	const double nu_b = 10; //Binding rate per second per free myosin per filament
	const double nu_ub = 10; //Unbining rate per second per bound myosin
	const double nu_a = 10; //rate of activation of crosslinks
	
	const double A_len = 10; // filament length
	
	//====================================================================================================================
	
	//====================================================================================================================
	//
	const double dt = 0.001;
	
	const double P_b = 1 - exp(-dt*nu_b); // Probability of binding
	const double P_ub = 1 - exp(-dt*nu_ub); // Probability of unbinding
	const double P_a = 1 - exp(-dt*nu_a); // probability fo becoming active
	
	long * idum = new long; // dummy long for random number generation
	(*idum) = 100;
	
	int t=0, i=0, j=0, k=0;// m=0;
	
	int kr=0, kc=0;
	
	
	double Ax[NumActin]; // filament CM coordinates
	double Mx[NumMyosin]; // positions of the Myosin
	
	double dx[NumActin]; // filemant speed
	
	int Mstate[NumMyosin]; // The state of the myosin[i]
	int Bound_id[NumMyosin]; // if true, then Bound_id[NumMyosin] actin is attached to Myosin
	int Cross_id[NumMyosin]; // same as Bound_id
	int A_pol[NumActin]; // Polarization of the myosin (+1 or -1) 
	
	double A_force[NumActin]; // The force on the Actin
	double A_drag[NumActin]; // The drag of the actin filament
	//--------------------------------------------------------------------------------------------------------------------
	// For Cluster Formation
	
	int ClusCount = 0; // the count of the cluster. Cluscount/2 is the number of crosslinkers
	int LabelC[2*NumMyosin];
	int LabelR[2*NumMyosin];
	int Labels[2*NumMyosin];
	int ClusDrag[2*NumMyosin];
	
	int tmp = 0;
	int check = 0;
	int incr = 0;
	
	//int test = 0;
	
	double tmp_double = 0;
	//--------------------------------------------------------------------------------------------------------------------
	
	//create the file for output
	
	ofstream* file = new ofstream("out.m");
	(*file)<<"Number of Actin = "<<NumActin<<endl;
	(*file)<<"Number of Myosin = "<<NumMyosin<<endl;
	(*file)<<"Binding Rate = "<<nu_b<<endl;
	(*file)<<"Unbinding Rate = "<<nu_ub<<endl;
	(*file)<<"Activation Rate = "<<nu_a<<endl;
	(*file)<<"System Size = "<<Lx<<endl;
	(*file)<<"Actin Length = "<<A_len<<endl;
	(*file)<<"Diffusion Constant = "<<D<<endl;
	file->close();
	delete file;
	
	//====================================================================================================================
	
	//====================================================================================================================
	//
	// Assing the Myosin and Actin the positions  
	double Temp;
	
	// Assing the Actin positions
	//Temp = Lx/NumActin;
	Temp = .4;
	for(i=0; i<NumActin; i++) // Generate random positions for each filament
	{	
		//Temp = ran2(idum);
		//Ax[i] = Lx*Temp;
		//Ax[i] = 75+i*Temp;
		
		if (i<(NumActin/2)) {
			//Ax[i] = 75 + i*Temp;
			Ax[i] = 104;
			A_pol[i] = 1;
		}
		else {
			//Ax[i] = 105 + i*Temp;
			Ax[i] = 96;
			A_pol[i] = -1;
		} 
		
	}
	
	for (i=0; i<NumActin; i++) {
		cout << Ax[i]<<" ";
	}
	cout << endl;
	
	// Assing the Actin its polarization
	
	/*
	 for (i=0; i<(NumActin/2); i++) {
	 A_pol[2*i] = 1;
	 A_pol[2*i+1] = -1;
	 } */
	
	
	// Assing the Myosin its position
	//Temp = Lx/NumMyosin;
	for(i=0; i<NumMyosin; i++) // Generate random positions for each Myosin
	{	
		//Temp = ran2(idum);
		//Mx[i] = Lx*Temp;
		Mx[i] = 100;
		Bound_id[i] = -1;
		Cross_id[i] = -1;
		Mstate[i] = 0;
	}
	
	
	// Assing the labels to -1
	
	for (i=0; i<NumActin; i++){
		LabelC[i] = -1;
		LabelR[i] = -1;
		Labels[i] = -1;
		ClusDrag[i] = 0;
	}
	
	//====================================================================================================================
	
	//====================================================================================================================
	//====================================================================================================================
	
	//cout << "Destruction Probability = " << NumFilaments*nu_d*dt<<endl;
	
	// time loop
	for(t=0; t< 10000000 ;t++)
	{
		if( !(t/1000.0-t/1000) ) { cout<<"Iteration # "<<t<<" Time= "<<t*dt<<endl;
		}
		
		
		/*for (k=0; k<NumMyosin; k++) {
		 if (Mstate[k] == 2) {
		 
		 if ((Bound_id[k] == -1)||(Cross_id[k] == -1)) {
		 cout << "BEFORE:The bound filaments of crosslink "<<k<<" are "<<Bound_id[k]<< " and "<<Cross_id[k]<<endl;
		 }
		 
		 }
		 }*/
		
		//----------------------------------------------------------------------------------------------------------------
		// Check Interactions, bind/unbind myosin, create/destroy Crosslinks, activate/deactivate Crosslinks
		for (j=0; j<NumMyosin; j++)
		{
			if (Mstate[j] == 0){ // If the Myosin is free
				for (k=0; (k<NumActin)&&(Mstate[j] == 0); k++) { // cycle until rebinds
					if (Interact(Mx[j], Ax[k], A_len, Lx) > 0) {
						if (ran2(idum) < P_b) { // if it binds
							Mstate[j] = 1;
							Bound_id[j] = k;
						}
					}
				}
			}
			
			else if(Mstate[j] == 1){ // If the Myosin is 1-Bound
				/*if (Bound_id[j] == -1) {
				 cout << "1 THE ERROR IS HERE because "<<"Bid = "<<Bound_id[j]<<" "<<Cross_id[j]<<endl;
				 
				 }*/
				
				
				
				if (ran2(idum) < P_ub) { // If it unbinds
					Mstate[j] = 0;
					Bound_id[j] = -1;
					// Then it can rebind again
					for (k=0; (k<NumActin)&&(Mstate[j] == 0); k++) { // cycle until rebinds
						if (Interact(Mx[j], Ax[k], A_len, Lx) > 0) {
							if (ran2(idum) < P_b) { // if it binds
								Mstate[j] = 1;
								Bound_id[j] = k;
							}
						}
					}
				}
				else { // If it remains bound
					for (k=0; (k<NumActin)&&(Mstate[j] == 1); k++) { // cycle until 2nd binds
						if (Interact(Mx[j], Ax[k], A_len, Lx) > 0) {
							if ((ran2(idum) < P_b)&&(A_pol[k] != A_pol[Bound_id[j]])) { // If it binds to a filament of opposite pol
								Mstate[j] = 2;
								Cross_id[j] = k;
								/*if ((Bound_id[j] == -1)||(Cross_id[j] == -1)) {
								 cout << "THE ERROR IS HERE"<<endl;
								 }*/
								
							}
						}
					}
				}
			}
			
			else if(Mstate[j] == 2){ // If the Myosin is a Crosslink
				if (ran2(idum) < P_a){ //If it is activated
					Mstate[j] = 3;
				}
				else if(ran2(idum) < P_ub){ // If one head falls off
					Mstate[j] = 1;
					Bound_id[j] = Cross_id[j];
					Cross_id[j] = -1;
					/*if (Bound_id[j] == -1) {
					 cout << "2 THE ERROR IS HERE because "<<"Bid = "<<Bound_id[j]<<" "<<Cross_id[j]<<endl;
					 
					 }*/
					
					
				}
				else if(ran2(idum) < P_ub){ // If the other head falls off
					Mstate[j] = 1;
					Cross_id[j] = -1;
					/*if (Bound_id[j] == -1) {
					 cout << "3 THE ERROR IS HERE because "<<"Bid = "<<Bound_id[j]<<" "<<Cross_id[j]<<endl;
					 
					 }*/
					
				}
			}
			
			else if(Mstate[j] == 3){ // If the Myosin is an Active Crosslink
				if (ran2(idum) < P_a){ // If it gets deactivated
					Mstate[j] = 2;
					
					/*if ((Bound_id[j] == -1)||(Cross_id[j] == -1)) {
					 cout << "The error is here"<<endl;
					 }*/
					
					
				}
				else if(ran2(idum) < P_ub){ // If one head falls off
					Mstate[j] = 1;
					Bound_id[j] = Cross_id[j];
					Cross_id[j] = -1;
					
					/*if (Bound_id[j] == -1) {
					 cout << "4 THE ERROR IS HERE because "<<"Bid = "<<Bound_id[j]<<" "<<Cross_id[j]<<endl;
					 
					 }*/
				}
				else if(ran2(idum) < P_ub){ // If the other head falls off
					Mstate[j] = 1;
					Cross_id[j] = -1;
					
					/*if (Bound_id[j] == -1) {
					 cout << "5 THE ERROR IS HERE because "<<"Bid = "<<Bound_id[j]<<" "<<Cross_id[j]<<endl;
					 
					 }*/
				}
				
				if (Interact(Mx[j], Ax[Cross_id[j]], A_len, Lx) < 1) { // If cross head no loger interacts
					Mstate[j] = 1;
					Cross_id[j] = -1;
					
					/*if (Bound_id[j] == -1) {
					 cout << "6 THE ERROR IS HERE because "<<"Bid = "<<Bound_id[j]<<" "<<Cross_id[j]<<endl;
					 
					 }*/
				}
				
				if (Interact(Mx[j], Ax[Bound_id[j]], A_len, Lx) < 1) { // If bound head no longer interacts
					Mstate[j] = 1;
					Bound_id[j] = -1;
					
					if (Cross_id[j] == -1) { // Both heads have fallen off
						Mstate[j] = 0;
					}
					else {
						Bound_id[j] = Cross_id[j];
						Cross_id[j] = 0;
					}
					
					
					/*if (Bound_id[j] == -1) {
					 cout << "Both Heads have fallen off because ";
					 cout<<"Bid = "<<Bound_id[j]<<" Cid = "<<Cross_id[j]<<" for Myosin "<<j<<endl;
					 cout << "The state of this myosin is "<<Mstate[j]<<endl;
					 }*/
				}
			}
			
			
		}
		
		/*
		 test = 0;
		 for (k=0; k<NumMyosin; k++) {
		 if (Mstate[k] == 2) {
		 
		 if ((Bound_id[k] == -1)||(Cross_id[k] == -1)) {
		 cout << "AFTER:The bound filaments of crosslink "<<k<<" are "<<Bound_id[k]<< " and "<<Cross_id[k]<<endl;
		 }
		 test++;
		 
		 }
		 }*/
		
		
		
		
		//----------------------------------------------------------------------------------------------------------------
		//Calculate force, Build Cluster, Move the constituents
		
		for (k=0; k<NumActin; k++){ // initialize the force to 0
			A_force[k] = 0;
			A_drag[k] = 1;
		}
		
		// Build Cluster
		
		
		for (j=0; j<(2*NumMyosin); j++){ // Initialize all labels to -1
			LabelC[j] = -1;
			LabelR[j] = -1;
			Labels[j] = -1;
			ClusDrag[j] = 0;
		}
		/*
		 cout << "NumCross = "<<NumCross<<endl;
		 
		 cout << " LabelC after init = [ ";
		 for (j=0; j<(2*NumMyosin); j++)
		 cout<<LabelC[j]<<" ";
		 cout << " ];"<<endl;
		 */
		ClusCount = 0; // The index of the clusters
		
		// Go through all the myosin
		for (j=0; j<NumMyosin; j++) { // Build the Labels
			if (Mstate[j] == 2) { // If Myosin[j] is inactive then it crosslinks 
				LabelC[ClusCount] = ClusCount; // Label of the myosin
				LabelC[ClusCount+1] = ClusCount; 
				LabelR[ClusCount] = Bound_id[j]; // Label of the actin
				LabelR[ClusCount+1] = Cross_id[j];
				ClusCount += 2;
				
				/*if ((Bound_id[j] == -1)||(Cross_id[j] == -1)) {
				 cout << "Error in the cluster"<<endl;
				 cout << "Bound_id = -1"<< " Cross_id is "<<Cross_id[j]<<endl;
				 cout << "The state of myosin is "<<Mstate[j]<<endl;
				 
				 for (k=0; k<NumMyosin; k++) {
				 if (Mstate[k] == 2) {
				 cout << "The bound filaments of crosslink "<<k<<" are "<<Bound_id[k]<< " and "<<Cross_id[k]<<endl;
				 }
				 }
				 } */
			}
			else if(Mstate[j] == 3){// If Myosin is Active then it applies a force to its two attached filaments
				A_force[Bound_id[j]] += alpha * A_pol[Bound_id[j]];
				A_force[Cross_id[j]] += alpha * A_pol[Cross_id[j]];
			}
		}
		
		/*	int check = 0;
		 k=0;
		 while (check != -1) {
		 check = LabelC[k];
		 k++;
		 }
		 
		 cout << "k = "<<k<<" ClusCount = "<<ClusCount<<" NumCross = "<<NumCross<<endl;
		 */
		/*
		 cout << " LabelC after build = [ ";
		 for (j=0; j<(2*NumMyosin); j++)
		 cout<<LabelC[j]<<" ";
		 cout << " ];"<<endl;
		 */
		for (kr=0; kr < ClusCount; kr++) { // Relabel the lablels 
			for (kc=0; kc < ClusCount; kc++) {
				if (LabelR[kr] == LabelR[kc]) {
					LabelC[kr] = LabelC[kc];
					if (fmod(kr, 2) == 1)
						LabelC[kr-1] = LabelC[kc];
					else 
						LabelC[kr+1] = LabelC[kc];
				}
			}
		}
		
		/*
		 cout << " LabelC after relabel =  [ ";
		 for (j=0; j<(2*NumMyosin); j++)
		 cout<<LabelC[j]<<" ";
		 cout << " ];"<<endl<<endl;
		 
		 cout << " LabelR = [ ";
		 for (j=0; j<(2*NumCross); j++)
		 cout<<LabelR[j]<<" ";
		 cout << " ];"<<endl;
		 */
		
		// Count the labels
		tmp = 0;check = 0;incr = 0;
		//int countc = 0;
		for (j=0; j<(ClusCount/2); j++) {
			tmp = LabelC[2*j];
			
			/*if (tmp == -1) {
			 cout << "tmp is -1"<<endl;
			 cout << "Clus Count is "<<ClusCount<<endl;
			 for (k=0; k<NumMyosin; k++) {
			 if (Mstate[k] == 2) {
			 countc++;
			 
			 }
			 }
			 
			 cout << "The number of crosslinks is "<<countc<<endl;
			 
			 cout << "LabelC = ";
			 for (m=0; m<ClusCount; m++) {
			 cout << LabelC[m]<<" ";
			 }
			 cout << endl; 
			 } */
			
			check = 0;
			for (k=0; k<incr; k++) {
				if (Labels[k] == tmp)
					check = 1;
			}
			
			if (check == 0){
				Labels[incr] = tmp;
				incr++;
			}
			
		}
		/*
		 cout << "LabelC = ";
		 for (j=0; j<(2*NumCross); j++) {
		 cout << LabelC[j]<<" ";
		 }
		 cout << endl;
		 
		 cout << "LabelR = ";
		 for (j=0; j<(2*NumCross); j++) {
		 cout << LabelR[j]<<" ";
		 }
		 cout << endl;
		 
		 cout << "Labels = ";
		 for (j=0; j<incr; j++) {
		 cout << Labels[j]<<" ";
		 }
		 cout << endl;
		 */
		/*cout << "Incr = "<<incr<<" and Labels = [ ";
		 for (j=0; j<incr; j++)
		 cout<<Labels[j]<<" ";
		 cout << " ];"<<endl<<endl;
		 */
		// Calculate Forces on the cluster by summing up all the forces within one cluster
		
		
		tmp_double = 0.0;
		
		for (j=0; j<incr;j++){ // Loop through the labels
			tmp_double = 0.0;
			
			/*if (Labels[j] == -1) {
			 cout << "Labels is -1"<<endl;
			 cout << Labels[j-1] << " "<< Labels[j] <<" " << incr<< endl;
			 }*/
			
			for (k=0;k<ClusCount;k++){ // Loop through the crosslinked filaments
				if (LabelC[k] == Labels[j]){
					//cout << "A force of LabelR[k]" << A_force[LabelR[k]] << endl;
					tmp_double += A_force[LabelR[k]]; // and sum up their force
					ClusDrag[j] += 1;
					/*if ((tmp_double > 1000)||(tmp_double < -1000)) {
					 cout << "Error"<<endl;
					 cout << "tmp_double = "<<tmp_double<<endl;
					 cout << "A_force = "<<A_force[LabelR[k]]<<endl;
					 cout << "LabelR = "<<LabelR[k]<<endl;
					 cout << "Labels = "<<Labels[j]<<endl;
					 cout << "LabelC = "<<LabelC[k]<<endl;
					 }*/
				}
			}
			for (k=0;k<ClusCount;k++) // Apply the summed force back the filaments
				if (LabelC[k] == Labels[j]){
					A_force[LabelR[k]] = tmp_double;
					A_drag[LabelR[k]] = ClusDrag[j];
				}
		}
		
		
		/*	for (k=0; k<NumActin; k++) {
		 if ((A_force[k] > 1000)||(A_force[k] < -1000)) {
		 cout << "ERROR"<<endl;
		 }
		 }
		 */	
		// For debugging purposes
		/*
		 if( !(i/1000.0-i/1000) )
		 {
		 ofstream myfile;
		 myfile.open("out.m", ios::app);
		 
		 
		 myfile<<"Actin_Pos=[ ";
		 for(j=0; j<NumActin; j++)
		 myfile<<Ax[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Actin_Pol=[ ";
		 for (j=0; j<NumActin; j++) 
		 myfile<<A_pol[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Myosin_Pos=[ ";
		 for(j=0; j<NumMyosin; j++)
		 myfile<<Mx[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Myosin State=[ ";
		 for (j=0; j<NumMyosin; j++)
		 myfile<<Mstate[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Bound_Id=[ ";
		 for (j=0; j<NumMyosin; j++)
		 myfile<<Bound_id[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Cross_Id=[ ";
		 for (j=0; j<NumMyosin; j++)
		 myfile<<Cross_id[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Number of Crosslinkers=[ "<<NumCross<<" "<<"];"<<endl;
		 
		 myfile<<"LabelR=[ ";
		 for (j=0; j<(2*NumCross); j++)
		 myfile<<LabelR[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"LabelC=[ ";
		 for (j=0; j<(2*NumCross); j++)
		 myfile<<LabelC[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Labels=[ ";
		 for (j=0; j<incr; j++)
		 myfile<<Labels[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<"Actin Force=[ ";
		 for (j=0; j<NumActin; j++) 
		 myfile<<A_force[j]<<" ";
		 myfile<<"];"<<endl;
		 
		 myfile<<endl;
		 
		 myfile.close();
		 }
		 */
		
		// Move the constituents
		// Move the Actin
		for (k=0; k<NumActin; k++){
			if (ran2(idum) < 0.50) {
				dx[k] = sqrt(2*D*dt) + A_force[k] * dt;
			}
			else {
				dx[k] = -sqrt(2*D*dt) + A_force[k] * dt;
			}
			Ax[k] += dx[k]/A_drag[k];
		}
		
		
		
		
		// Move the Myosin
		for(j=0; j<NumMyosin; j++){ // Move by Diffusion
			
			if (Mstate[j] == 0){ // Free Myosin Moved by diffusion only
				if (ran2(idum) < 0.50)
					Mx[j] += sqrt(2*D*dt);
				else
					Mx[j] += -sqrt(2*D*dt);
			}
			
			else if (Mstate[j] == 1) {
				Mx[j] += dx[Bound_id[j]];
			}
			
			else if (Mstate[j] == 2) {
				Mx[j] += dx[Bound_id[j]];
			}
			
			else if (Mstate[j] == 3) {
				if (ran2(idum) < 0.50)
					Mx[j] += sqrt(2*D*dt);
				else
					Mx[j] += -sqrt(2*D*dt);
			}
		}
		/*
		 cout << "dx = ";
		 for (k = 0; k<NumActin; k++) {
		 cout<<dx[k]<<" ";
		 }
		 cout << endl;
		 
		 cout<<"Mx = ";
		 for (j=0; j<NumMyosin; j++) {
		 cout << Mx[j]<<" ";
		 }
		 cout << endl;
		 */
		//----------------------------------------------------------------------------------------------------------------
		
		
		// apply boundary conditions
		for(j=0; j<NumMyosin; j++)
		{
			if(Mx[j]>Lx)
				Mx[j] += -Lx;
			else if(Mx[j]<0)
				Mx[j] += Lx;
		}
		
		for(k=0; k<NumActin; k++)
		{
			if(Ax[k]>Lx)
				Ax[k] += -Lx;
			else if(Ax[k]<0)
				Ax[k] += Lx;
		}
		
		for (k=0; k<NumActin; k++){
			if ((Ax[k] > Lx)||(Ax[k] < 0)) {
				cout << "FUCKING ERROR"<<endl;
				cout << "Ax = " << Ax[k]<<endl;
			}
		}
		
		for (j=0; j<NumMyosin; j++) {
			if ((Mx[j] > Lx)||(Mx[j] < 0)) {
				cout << "FUCKING ERROR"<<endl;
				cout << "Mx = " << Mx[j]<<endl;
			}
		}
		
		
		
		//----------------------------------------------------------------------------------------------------------------
		
		// Record the data
		if( !(t/1000.0-t/1000) )
		{
			
			
			ofstream myfile;
			myfile.open("out.m", ios::app);
			
			myfile<<"Time=[ "<<t*dt<<" ];"<<endl;
			
			myfile<<"Actin_Pos=[ ";
			for(j=0; j<NumActin; j++)
				myfile<<Ax[j]<<" ";
			myfile<<"];"<<endl;
			
			myfile<<"Myosin_Pos=[ ";
			for(j=0; j<NumMyosin; j++)
				myfile<<Mx[j]<<" ";
			myfile<<"];"<<endl;
			/*
			 myfile<<"Actin_Pol=[ ";
			 for (j=0; j<NumActin; j++) 
			 myfile<<A_pol[j]<<" ";
			 myfile<<"];"<<endl;
			 
			 myfile<<"Bound_Id=[ ";
			 for (j=0; j<NumMyosin; j++)
			 myfile<<Bound_id[j]<<" ";
			 myfile<<"];"<<endl;
			 
			 myfile<<"Cross_Id=[ ";
			 for (j=0; j<NumMyosin; j++)
			 myfile<<Cross_id[j]<<" ";
			 myfile<<"];"<<endl;
			 
			 myfile<<"Number of Crosslinkers=[ "<<NumCross<<" "<<"];"<<endl;
			 
			 myfile<<"LabelR=[ ";
			 for (j=0; j<(2*NumCross); j++)
			 myfile<<LabelR[j]<<" ";
			 myfile<<"];"<<endl;
			 
			 myfile<<"LabelC=[ ";
			 for (j=0; j<(2*NumCross); j++)
			 myfile<<LabelC[j]<<" ";
			 myfile<<"];"<<endl;
			 
			 myfile<<"Labels=[ ";
			 for (j=0; j<incr; j++)
			 myfile<<Labels[j]<<" ";
			 myfile<<"];"<<endl; 
			 */
			myfile<<"Myosin State=[ ";
			for (j=0; j<NumMyosin; j++)
				myfile<<Mstate[j]<<" ";
			myfile<<"];"<<endl;
			
			myfile<<"Actin_Pol=[ ";
			for (j=0; j<NumActin; j++) 
				myfile<<A_pol[j]<<" ";
			myfile<<"];"<<endl;
			
			myfile<<"Actin Force=[ ";
			for (j=0; j<NumActin; j++) 
				myfile<<A_force[j]<<" ";
			myfile<<"];"<<endl;
			
			myfile<<"Actin dx=[ ";
			for (j=0; j<NumActin; j++) 
				myfile<<dx[j]<<" ";
			myfile<<"];"<<endl;
			
			myfile.close();
		} 
		
		
	}
	
	return 1;
}
